/*
    Copyright 2011, Strategic Gains, Inc.

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/
package com.strategicgains.repoexpress.adapter;

import com.strategicgains.repoexpress.exception.InvalidObjectIdException;

/**
 * Converts a string ID into an Object, such as an ObjectId (e.g. MongoDB) before reading.
 * 
 * @author toddf
 * @since Feb 16, 2011
 */
public interface IdentiferAdapter<I>
{
	public I convert(String id)
	throws InvalidObjectIdException;
}
